/*
 * This file is part of rasdaman community.
 *
 * Rasdaman community is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Rasdaman community is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with rasdaman community.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright 2003, 2004, 2005, 2006, 2007, 2008, 2009 Peter Baumann /
 rasdaman GmbH.
 *
 * For more information please see <http://www.rasdaman.org>
 * or contact Peter Baumann via <baumann@rasdaman.com>.
 */
#include <iostream>

#include "version.h"
#include "config.h"

#ifdef EARLY_TEMPLATE
#define __EXECUTABLE__
#include "raslib/template_inst.hh"
#endif

#include <pthread.h>
#include <easylogging++.h>
#include "rasodmg/transaction.hh"
#include "rasodmg/database.hh"

using namespace std;

const unsigned int THREAD_NO = 2;

void* query_thread(void *ptr)
{
    r_Database db;
    r_Transaction ta;

    db.set_servername("localhost", 7001);
    db.set_useridentification("rasguest", "rasguest");
    db.open("RASBASE");

    ta.begin(r_Transaction::read_only);
    r_Set< r_Ref_Any > result_set;
    r_OQL_Query query("select avg_cells(c) from rgb as c");
    r_oql_execute(query, result_set);
    ta.commit();

    db.close();

    pthread_exit(0);
}

_INITIALIZE_EASYLOGGINGPP

int main(int ac, char** av)
{
    pthread_t threads[THREAD_NO];

    for (unsigned int i = 0; i < THREAD_NO; i++)
    {
        pthread_create(&threads[i], NULL, query_thread, &i);
    }
    for (unsigned int i = 0; i < THREAD_NO; i++)
    {
        pthread_join(threads[i], NULL);
    }

    return 0;
}
